--- /dev/null
+#!/bin/bash
+
+# This is part of "osstest", an automated testing framework for Xen.
+# Copyright (C) 2017 Citrix Inc.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -xe -o posix
+
+arch=`perl -e '
+ use Osstest;
+ use Osstest::TestSupport;
+
+ tsreadconfig();
+ print $r{"arch"} or die $!;
+ '`
+
+case "$arch" in
+amd64)
+ ;;
+*)
+ echo "Arch $arch not supported for memdisk tests"
+ exit 0
+ ;;
+esac
+
+if ./ts-freebsd-host-install --test-boot --record-append $@; then
+ exit 0
+elif ./ts-freebsd-host-install --test-boot --record-append \
+ --memdisk-append="raw" $@; then
+ exit 0
+fi
+
+exit 1